<!DOCTYPE html>
<html>
<head>
    <title>Systems Status</title>
    <style>
      th, td, p, input {
        font:14px, Verdana;
      }
      table, th, td {
        border: solid 5px #DDD;
        border-collapse: collapse;
        padding: 20px 30px;
        text-align: center;
      }
      th {
        font-weight:bold;
      }
    </style>
</head>
<body>
  <p id="dataTable"></p>
  <script>
    document.addEventListener('DOMContentLoaded', function() {
        showTable()
    })
  </script>
</body>
<script>
function fetchFromURL(url, completion) {
    completion(
            {
                "name": "Example 1",
                "url": url,
                "uptime": "31:21:12.19 DOUBLE CHECK THIS FORMAT",
                "ramUsed": "1.22 GB",
                "maxRam": "4 GB",
                "ramPercentageUsed": "36%",
                "cpuPercentageUsed": "23.82%",
                "storageUsed": "116.29 GB",
                "maxStorage": "256 GB",
                "storagePercentageUsed": "45.43%",
                "temperature": "142.18 F"
            }
    )
}

function fetchData(urls, completion) {
    var systems = []
    var iterationsCompleted = 0
    urls.forEach(function (url) {
        fetchFromURL(url, function (status) {
            iterationsCompleted++
            systems.push(status)

            if (iterationsCompleted === urls.length) {
                completion(systems)
            }
        })
    })
}

function retrieveURLs() {
    return [
        "https://example1.local",
        "https://example2.local",
        "https://example3.local"
    ]
}

function showTable() {
    fetchData(retrieveURLs(), function (systems) {
        // extract value for html header
        var col = [];
        for (var i = 0; i< systems.length; i++) {
          for (var key in systems[i]) {
            if (col.indexOf(key) === -1) {
              col.push(key);
            }
          }
        }

        // create dynamic table
        var table = document.createElement("table"); // table row

        // create html table header row using the extracted headers above
        var tr = table.insertRow(-1);

        for (var i = 0; i < col.length; i++) {
          var th = document.createElement("th"); // table header
          th.innerHTML = col[i];
          tr.appendChild(th);
        }

        // add json data to the table as rows
        for (var i = 0; i < systems.length; i++) {
          tr = table.insertRow(-1);

          for (var j = 0; j < col.length; j++) {
            var tabCell = tr.insertCell(-1);
            var key = col[i];
            if (j === 1) {
              tabCell.innerHTML = '<a href="' + systems[i][col[j]] + '">' + systems[i][col[j]] + '</a>';
            } else {
              tabCell.innerHTML = systems[i][col[j]];
            }
          }
        }

        // finally, add the newly created table with json data to a container
        var divContainer = document.getElementById("dataTable");
        if (divContainer.hasChildNodes()) {
          divContainer.innerHTML = "";
        } else {
          divContainer.appendChild(table);
        }
    })
}
</script>
</html>
